
#!/bin/bash

# 定义要 ping 的 IP 地址
TARGET_IP="10.10.30.214"  # 请替换为你需要 ping 的 IP 地址
# 定义日志文件名
LOG_FILE="ping_results.log"
# 定义告警文件名
ALERT_FILE="ping_alert.log"

# 清空日志文件
> "$LOG_FILE"

while true; do
    # 执行 ping 命令，并将结果输出到日志文件
    ping -c 1 "$TARGET_IP" >> "$LOG_FILE"

    # 检查 ping 命令是否成功执行
    if [ $? -ne 0 ]; then
        # 如果 ping 失败，输出告警信息到告警文件
        echo "$(date '+%Y-%m-%d %H:%M:%S') - Ping to $TARGET_IP failed." >> "$ALERT_FILE"
    fi

    # 等待一段时间再继续下一次 ping
    sleep 1
done
